import astropy,os,scipy
#import matplotlib.pyplot as plt
import numpy as np
from astropy.io import fits
from scipy.interpolate import Rbf, InterpolatedUnivariateSpline
#from matplotlib import cm
from scipy.ndimage import gaussian_filter1d

xx=np.linspace(127.5,1919.5,8)
yy=np.linspace(125.5,1889.5,8)
y=np.linspace(0,2047,2048)
x=np.linspace(0,2035,2036)

aa=np.empty((16,64))
bb=np.empty((16,64))
cc=np.empty((3,64))
#print xx,yy

f=open('fitting_para.dat')
for k in range(16):
    f.readline()
    for i in range(64):
        s=f.readline()
        s=s.strip("\n")
        arr=s.split(' ')
        aa[k,i]=arr[0]
        bb[k,i]=arr[3]

for line in open("fits.lst"):
    line=line.strip("\n")

flat=fits.open('bias_'+line[1:6]+'fits')
for k in range(16):
    print('CCD  ',k+1)

    data=flat[k+1].data

    for m in range(8):
        for n in range(8):
            cc[2,m*8+n]=bb[k,m*8+n]
            cc[1,m*8+n]=xx[m]
            cc[0,m*8+n]=yy[n]

    xxx=cc[0]
    yyy=cc[1]
    zzz=cc[2]

    XI, YI = np.meshgrid(x, y)
    rbf = Rbf(xxx, yyy, zzz)
    ZI = rbf(XI, YI)

    data=ZI.astype(np.float32)
    if (k == 8) or (k ==9) or (k == 10) or (k == 11):
        para_b=scipy.ndimage.filters.gaussian_filter(data[:,:2016],100)
        flat[k+1].data[:,:2016]=para_b
    else:
        flat[k+1].data=data

flat.writeto('linear_b.fits',clobber='Ture')
flat.close()
#n = plt.normalize(-2., 2.)
#plt.subplot(1, 1, 1)
#plt.pcolor(XI, YI, ZI, cmap=cm.jet)
#plt.scatter(xxx, yyy, 64, zzz, cmap=cm.jet)
#>>> plt.title('RBF interpolation - multiquadrics')
#>>> plt.xlim(-2, 2)
#>>> plt.ylim(-2, 2)
#plt.colorbar()
#plt.show()
